/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/

cordova.define("org.apache.cordova.file-transfer.FileTransfer",function(e,r,n){function o(e){var r=new u;return r.lengthComputable=e.lengthComputable,r.loaded=e.loaded,r.total=e.total,r}function a(e){var r=/^https?\:\/\/(?:(?:(([^:@\/]*)(?::([^@\/]*))?)?@)?([^:\/?#]*)(?::(\d*))?).*$/,n=r.exec(e);return n&&n[1]}function t(e){var r=null;if(window.btoa){var n=a(e);if(n){var o="Authorization",t="Basic "+window.btoa(n);r={name:o,value:t}}}return r}var i=e("cordova/argscheck"),l=e("cordova/exec"),s=e("./FileTransferError"),u=e("org.apache.cordova.file.ProgressEvent"),d=0,f=function(){this._id=++d,this.onprogress=null};f.prototype.upload=function(e,r,n,u,d,f){i.checkArgs("ssFFO*","FileTransfer.upload",arguments);var c=null,p=null,h=null,v=null,m=!0,g=null,y=null,F=t(r);if(F)r=r.replace(a(r)+"@",""),d=d||{},d.headers=d.headers||{},d.headers[F.name]=F.value;if(d){if(c=d.fileKey,p=d.fileName,h=d.mimeType,g=d.headers,y=d.httpMethod||"POST","PUT"==y.toUpperCase())y="PUT";else y="POST";if(null!==d.chunkedMode||"undefined"!=typeof d.chunkedMode)m=d.chunkedMode;if(d.params)v=d.params;else v={}}var w=u&&function(e){var r=new s(e.code,e.source,e.target,e.http_status,e.body,e.exception);u(r)},T=this,b=function(e){if("undefined"!=typeof e.lengthComputable){if(T.onprogress)T.onprogress(o(e))}else n&&n(e)};l(b,w,"FileTransfer","upload",[e,r,c,p,h,v,f,m,g,this._id,y])},f.prototype.download=function(r,n,u,d,f,c){i.checkArgs("ssFF*","FileTransfer.download",arguments);var p=this,h=t(r);if(h)r=r.replace(a(r)+"@",""),c=c||{},c.headers=c.headers||{},c.headers[h.name]=h.value;var v=null;if(c)v=c.headers||null;var m=function(r){if("undefined"!=typeof r.lengthComputable){if(p.onprogress)return p.onprogress(o(r))}else if(u){var n=null;if(r.isDirectory)n=new(e("org.apache.cordova.file.DirectoryEntry"));else if(r.isFile)n=new(e("org.apache.cordova.file.FileEntry"));n.isDirectory=r.isDirectory,n.isFile=r.isFile,n.name=r.name,n.fullPath=r.fullPath,n.filesystem=new FileSystem(r.filesystemName||(r.filesystem==window.PERSISTENT?"persistent":"temporary")),n.nativeURL=r.nativeURL,u(n)}},g=d&&function(e){var r=new s(e.code,e.source,e.target,e.http_status,e.body,e.exception);d(r)};l(m,g,"FileTransfer","download",[r,n,f,this._id,v])},f.prototype.abort=function(){l(null,null,"FileTransfer","abort",[this._id])},n.exports=f});