/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/

cordova.define("org.apache.cordova.file.FileReader",function(e,t,r){function o(e){d.defineGetterSetter(u.prototype,e,function(){return this._realReader[e]||null},function(t){this._realReader[e]=t})}function n(e,t){if(e.readyState==u.LOADING)throw new l(l.INVALID_STATE_ERR);if(e._result=null,e._error=null,e._readyState=u.LOADING,"string"==typeof t.localURL)e._localURL=t.localURL;else return e._localURL="",!0;e.onloadstart&&e.onloadstart(new f("loadstart",{target:e}))}var a=e("cordova/exec"),i=e("cordova/modulemapper"),d=e("cordova/utils"),l=(e("./File"),e("./FileError")),f=e("./ProgressEvent"),s=i.getOriginalSymbol(window,"FileReader"),u=function(){this._readyState=0,this._error=null,this._result=null,this._localURL="",this._realReader=s?new s:{}};u.EMPTY=0,u.LOADING=1,u.DONE=2,d.defineGetter(u.prototype,"readyState",function(){return this._localURL?this._readyState:this._realReader.readyState}),d.defineGetter(u.prototype,"error",function(){return this._localURL?this._error:this._realReader.error}),d.defineGetter(u.prototype,"result",function(){return this._localURL?this._result:this._realReader.result}),o("onloadstart"),o("onprogress"),o("onload"),o("onerror"),o("onloadend"),o("onabort"),u.prototype.abort=function(){if(s&&!this._localURL)return this._realReader.abort();if(this._result=null,this._readyState!=u.DONE&&this._readyState!=u.EMPTY){if(this._readyState=u.DONE,"function"==typeof this.onabort)this.onabort(new f("abort",{target:this}));if("function"==typeof this.onloadend)this.onloadend(new f("loadend",{target:this}))}},u.prototype.readAsText=function(e,t){if(n(this,e))return this._realReader.readAsText(e,t);var r=t?t:"UTF-8",o=this,i=[this._localURL,r,e.start,e.end];a(function(e){if(o._readyState!==u.DONE){if(o._readyState=u.DONE,o._result=e,"function"==typeof o.onload)o.onload(new f("load",{target:o}));if("function"==typeof o.onloadend)o.onloadend(new f("loadend",{target:o}))}},function(e){if(o._readyState!==u.DONE){if(o._readyState=u.DONE,o._result=null,o._error=new l(e),"function"==typeof o.onerror)o.onerror(new f("error",{target:o}));if("function"==typeof o.onloadend)o.onloadend(new f("loadend",{target:o}))}},"File","readAsText",i)},u.prototype.readAsDataURL=function(e){if(n(this,e))return this._realReader.readAsDataURL(e);var t=this,r=[this._localURL,e.start,e.end];a(function(e){if(t._readyState!==u.DONE){if(t._readyState=u.DONE,t._result=e,"function"==typeof t.onload)t.onload(new f("load",{target:t}));if("function"==typeof t.onloadend)t.onloadend(new f("loadend",{target:t}))}},function(e){if(t._readyState!==u.DONE){if(t._readyState=u.DONE,t._result=null,t._error=new l(e),"function"==typeof t.onerror)t.onerror(new f("error",{target:t}));if("function"==typeof t.onloadend)t.onloadend(new f("loadend",{target:t}))}},"File","readAsDataURL",r)},u.prototype.readAsBinaryString=function(e){if(n(this,e))return this._realReader.readAsBinaryString(e);var t=this,r=[this._localURL,e.start,e.end];a(function(e){if(t._readyState!==u.DONE){if(t._readyState=u.DONE,t._result=e,"function"==typeof t.onload)t.onload(new f("load",{target:t}));if("function"==typeof t.onloadend)t.onloadend(new f("loadend",{target:t}))}},function(e){if(t._readyState!==u.DONE){if(t._readyState=u.DONE,t._result=null,t._error=new l(e),"function"==typeof t.onerror)t.onerror(new f("error",{target:t}));if("function"==typeof t.onloadend)t.onloadend(new f("loadend",{target:t}))}},"File","readAsBinaryString",r)},u.prototype.readAsArrayBuffer=function(e){if(n(this,e))return this._realReader.readAsArrayBuffer(e);var t=this,r=[this._localURL,e.start,e.end];a(function(e){if(t._readyState!==u.DONE){if(t._readyState=u.DONE,t._result=e,"function"==typeof t.onload)t.onload(new f("load",{target:t}));if("function"==typeof t.onloadend)t.onloadend(new f("loadend",{target:t}))}},function(e){if(t._readyState!==u.DONE){if(t._readyState=u.DONE,t._result=null,t._error=new l(e),"function"==typeof t.onerror)t.onerror(new f("error",{target:t}));if("function"==typeof t.onloadend)t.onloadend(new f("loadend",{target:t}))}},"File","readAsArrayBuffer",r)},r.exports=u});