/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/

cordova.define("org.apache.cordova.globalization.globalization",function(t,a,e){var n=t("cordova/argscheck"),o=t("cordova/exec"),i=(t("./GlobalizationError"),{getPreferredLanguage:function(t,a){n.checkArgs("fF","Globalization.getPreferredLanguage",arguments),o(t,a,"Globalization","getPreferredLanguage",[])},getLocaleName:function(t,a){n.checkArgs("fF","Globalization.getLocaleName",arguments),o(t,a,"Globalization","getLocaleName",[])},dateToString:function(t,a,e,i){n.checkArgs("dfFO","Globalization.dateToString",arguments);var r=t.valueOf();o(a,e,"Globalization","dateToString",[{date:r,options:i}])},stringToDate:function(t,a,e,i){n.checkArgs("sfFO","Globalization.stringToDate",arguments),o(a,e,"Globalization","stringToDate",[{dateString:t,options:i}])},getDatePattern:function(t,a,e){n.checkArgs("fFO","Globalization.getDatePattern",arguments),o(t,a,"Globalization","getDatePattern",[{options:e}])},getDateNames:function(t,a,e){n.checkArgs("fFO","Globalization.getDateNames",arguments),o(t,a,"Globalization","getDateNames",[{options:e}])},isDayLightSavingsTime:function(t,a,e){n.checkArgs("dfF","Globalization.isDayLightSavingsTime",arguments);var i=t.valueOf();o(a,e,"Globalization","isDayLightSavingsTime",[{date:i}])},getFirstDayOfWeek:function(t,a){n.checkArgs("fF","Globalization.getFirstDayOfWeek",arguments),o(t,a,"Globalization","getFirstDayOfWeek",[])},numberToString:function(t,a,e,i){n.checkArgs("nfFO","Globalization.numberToString",arguments),o(a,e,"Globalization","numberToString",[{number:t,options:i}])},stringToNumber:function(t,a,e,i){n.checkArgs("sfFO","Globalization.stringToNumber",arguments),o(a,e,"Globalization","stringToNumber",[{numberString:t,options:i}])},getNumberPattern:function(t,a,e){n.checkArgs("fFO","Globalization.getNumberPattern",arguments),o(t,a,"Globalization","getNumberPattern",[{options:e}])},getCurrencyPattern:function(t,a,e){n.checkArgs("sfF","Globalization.getCurrencyPattern",arguments),o(a,e,"Globalization","getCurrencyPattern",[{currencyCode:t}])}});e.exports=i});