/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/

cordova.define("org.apache.cordova.inappbrowser.inappbrowser",function(e,n,r){function o(){this.channels={loadstart:t.create("loadstart"),loadstop:t.create("loadstop"),loaderror:t.create("loaderror"),exit:t.create("exit")}}var i=e("cordova/exec"),t=e("cordova/channel"),l=e("cordova/modulemapper"),c=e("cordova/urlutil");o.prototype={_eventHandler:function(e){if(e&&e.type in this.channels)this.channels[e.type].fire(e)},close:function(){i(null,null,"InAppBrowser","close",[])},show:function(){i(null,null,"InAppBrowser","show",[])},addEventListener:function(e,n){if(e in this.channels)this.channels[e].subscribe(n)},removeEventListener:function(e,n){if(e in this.channels)this.channels[e].unsubscribe(n)},executeScript:function(e,n){if(e.code)i(n,null,"InAppBrowser","injectScriptCode",[e.code,!!n]);else if(e.file)i(n,null,"InAppBrowser","injectScriptFile",[e.file,!!n]);else throw new Error("executeScript requires exactly one of code or file to be specified")},insertCSS:function(e,n){if(e.code)i(n,null,"InAppBrowser","injectStyleCode",[e.code,!!n]);else if(e.file)i(n,null,"InAppBrowser","injectStyleFile",[e.file,!!n]);else throw new Error("insertCSS requires exactly one of code or file to be specified")}},r.exports=function(e,n,r,t){if(window.frames&&window.frames[n]){var s=l.getOriginalSymbol(window,"open");return s.apply(window,arguments)}e=c.makeAbsolute(e);var a=new o;t=t||{};for(var p in t)a.addEventListener(p,t[p]);var d=function(e){a._eventHandler(e)};return r=r||"",i(d,d,"InAppBrowser","open",[e,n,r]),a}});