/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/

cordova.define("org.apache.cordova.contacts.Contact",function(t,n,e){function o(t){var n=t.birthday;try{t.birthday=new Date(parseFloat(n))}catch(e){console.log("Cordova Contact convertIn error: exception creating date.")}return t}function i(t){var n=t.birthday;if(null!==n){if(!l.isDate(n))try{n=new Date(n)}catch(e){n=null}if(l.isDate(n))n=n.valueOf();t.birthday=n}return t}var a=t("cordova/argscheck"),r=t("cordova/exec"),s=t("./ContactError"),l=t("cordova/utils"),c=function(t,n,e,o,i,a,r,s,l,c,u,h,d,v){this.id=t||null,this.rawId=null,this.displayName=n||null,this.name=e||null,this.nickname=o||null,this.phoneNumbers=i||null,this.emails=a||null,this.addresses=r||null,this.ims=s||null,this.organizations=l||null,this.birthday=c||null,this.note=u||null,this.photos=h||null,this.categories=d||null,this.urls=v||null};c.prototype.remove=function(t,n){a.checkArgs("FF","Contact.remove",arguments);var e=n&&function(t){n(new s(t))};if(null===this.id)e(s.UNKNOWN_ERROR);else r(t,e,"Contacts","remove",[this.id])},c.prototype.clone=function(){function t(t){if(t)for(var n=0;n<t.length;++n)t[n].id=null}var n=l.clone(this);return n.id=null,n.rawId=null,t(n.phoneNumbers),t(n.emails),t(n.addresses),t(n.ims),t(n.organizations),t(n.categories),t(n.photos),t(n.urls),n},c.prototype.save=function(n,e){a.checkArgs("FFO","Contact.save",arguments);var c=e&&function(t){e(new s(t))},u=function(e){if(e){if(n){var i=t("./contacts").create(e);n(o(i))}}else c(s.UNKNOWN_ERROR)},h=i(l.clone(this));r(u,c,"Contacts","save",[h])},e.exports=c});