/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/

cordova.define("org.apache.cordova.geolocation.geolocation",function(e,t,i){function a(e){var t={maximumAge:0,enableHighAccuracy:!1,timeout:1/0};if(e){if(void 0!==e.maximumAge&&!isNaN(e.maximumAge)&&e.maximumAge>0)t.maximumAge=e.maximumAge;if(void 0!==e.enableHighAccuracy)t.enableHighAccuracy=e.enableHighAccuracy;if(void 0!==e.timeout&&!isNaN(e.timeout))if(e.timeout<0)t.timeout=0;else t.timeout=e.timeout}return t}function o(e,t){var i=setTimeout(function(){clearTimeout(i),i=null,e({code:u.TIMEOUT,message:"Position retrieval timed out."})},t);return i}var c=e("cordova/argscheck"),n=e("cordova/utils"),m=e("cordova/exec"),u=e("./PositionError"),r=e("./Position"),l={},s={lastPosition:null,getCurrentPosition:function(e,t,i){c.checkArgs("fFO","geolocation.getCurrentPosition",arguments),i=a(i);var n={timer:null},l=function(t){if(clearTimeout(n.timer),n.timer){var i=new r({latitude:t.latitude,longitude:t.longitude,altitude:t.altitude,accuracy:t.accuracy,heading:t.heading,velocity:t.velocity,altitudeAccuracy:t.altitudeAccuracy},void 0===t.timestamp?new Date:t.timestamp instanceof Date?t.timestamp:new Date(t.timestamp));s.lastPosition=i,e(i)}},g=function(e){clearTimeout(n.timer),n.timer=null;var i=new u(e.code,e.message);if(t)t(i)};if(s.lastPosition&&i.maximumAge&&(new Date).getTime()-s.lastPosition.timestamp.getTime()<=i.maximumAge)e(s.lastPosition);else if(0===i.timeout)g({code:u.TIMEOUT,message:"timeout value in PositionOptions set to 0 and no cached Position object available, or cached Position object's age exceeds provided PositionOptions' maximumAge parameter."});else{if(1/0!==i.timeout)n.timer=o(g,i.timeout);else n.timer=!0;m(l,g,"Geolocation","getLocation",[i.enableHighAccuracy,i.maximumAge])}return n},watchPosition:function(e,t,i){c.checkArgs("fFO","geolocation.getCurrentPosition",arguments),i=a(i);var g=n.createUUID();l[g]=s.getCurrentPosition(e,t,i);var d=function(e){clearTimeout(l[g].timer);var i=new u(e.code,e.message);if(t)t(i)},f=function(t){if(clearTimeout(l[g].timer),1/0!==i.timeout)l[g].timer=o(d,i.timeout);var a=new r({latitude:t.latitude,longitude:t.longitude,altitude:t.altitude,accuracy:t.accuracy,heading:t.heading,velocity:t.velocity,altitudeAccuracy:t.altitudeAccuracy},void 0===t.timestamp?new Date:t.timestamp instanceof Date?t.timestamp:new Date(t.timestamp));s.lastPosition=a,e(a)};return m(f,d,"Geolocation","addWatch",[g,i.enableHighAccuracy]),g},clearWatch:function(e){if(e&&void 0!==l[e])clearTimeout(l[e].timer),l[e].timer=!1,m(null,null,"Geolocation","clearWatch",[e])}};i.exports=s});