/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/

cordova.define("org.apache.cordova.device-orientation.compass",function(e,a,n){var r=e("cordova/argscheck"),i=e("cordova/exec"),t=e("cordova/utils"),c=e("./CompassHeading"),o=e("./CompassError"),s={},d={getCurrentHeading:function(e,a,n){r.checkArgs("fFO","compass.getCurrentHeading",arguments);var t=function(a){var n=new c(a.magneticHeading,a.trueHeading,a.headingAccuracy,a.timestamp);e(n)},s=a&&function(e){var n=new o(e);a(n)};i(t,s,"Compass","getHeading",[n])},watchHeading:function(e,a,n){r.checkArgs("fFO","compass.watchHeading",arguments);var i=void 0!==n&&void 0!==n.frequency?n.frequency:100,c=void 0!==n&&void 0!==n.filter?n.filter:0,o=t.createUUID();if(c>0)s[o]="iOS",d.getCurrentHeading(e,a,n);else s[o]=window.setInterval(function(){d.getCurrentHeading(e,a)},i);return o},clearWatch:function(e){if(e&&s[e]){if("iOS"!=s[e])clearInterval(s[e]);else i(null,null,"Compass","stopHeading",[]);delete s[e]}}};n.exports=d});