/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/

cordova.define("org.apache.cordova.file.Entry",function(t,e,n){function o(t,e,n,o,i,r){this.isFile=!!t,this.isDirectory=!!e,this.name=n||"",this.fullPath=o||"",this.filesystem=i||null,this.nativeURL=r||null}var i=t("cordova/argscheck"),r=t("cordova/exec"),a=t("./FileError"),s=t("./Metadata");o.prototype.getMetadata=function(t,e){i.checkArgs("FF","Entry.getMetadata",arguments);var n=t&&function(e){var n=new s({size:e.size,modificationTime:e.lastModifiedDate});t(n)},o=e&&function(t){e(new a(t))};r(n,o,"File","getFileMetadata",[this.toInternalURL()])},o.prototype.setMetadata=function(t,e,n){i.checkArgs("FFO","Entry.setMetadata",arguments),r(t,e,"File","setMetadata",[this.toInternalURL(),n])},o.prototype.moveTo=function(e,n,o,s){i.checkArgs("oSFF","Entry.moveTo",arguments);var l=s&&function(t){s(new a(t))},c=this.toInternalURL(),f=n||this.name,u=function(n){if(n){if(o){var i=n.isDirectory?new(t("./DirectoryEntry"))(n.name,n.fullPath,e.filesystem,n.nativeURL):new(t("org.apache.cordova.file.FileEntry"))(n.name,n.fullPath,e.filesystem,n.nativeURL);o(i)}}else l&&l(a.NOT_FOUND_ERR)};r(u,l,"File","moveTo",[c,e.toInternalURL(),f])},o.prototype.copyTo=function(e,n,o,s){i.checkArgs("oSFF","Entry.copyTo",arguments);var l=s&&function(t){s(new a(t))},c=this.toInternalURL(),f=n||this.name,u=function(n){if(n){if(o){var i=n.isDirectory?new(t("./DirectoryEntry"))(n.name,n.fullPath,e.filesystem,n.nativeURL):new(t("org.apache.cordova.file.FileEntry"))(n.name,n.fullPath,e.filesystem,n.nativeURL);o(i)}}else l&&l(a.NOT_FOUND_ERR)};r(u,l,"File","copyTo",[c,e.toInternalURL(),f])},o.prototype.toInternalURL=function(){if(this.filesystem&&this.filesystem.__format__)return this.filesystem.__format__(this.fullPath);else return void 0},o.prototype.toURL=function(){if(this.nativeURL)return this.nativeURL;else return this.toInternalURL()||"file://localhost"+this.fullPath},o.prototype.toNativeURL=function(){return console.log("DEPRECATED: Update your code to use 'toURL'"),this.toURL()},o.prototype.toURI=function(){return console.log("DEPRECATED: Update your code to use 'toURL'"),this.toURL()},o.prototype.remove=function(t,e){i.checkArgs("FF","Entry.remove",arguments);var n=e&&function(t){e(new a(t))};r(t,n,"File","remove",[this.toInternalURL()])},o.prototype.getParent=function(e,n){i.checkArgs("FF","Entry.getParent",arguments);var o=this.filesystem,s=e&&function(n){var i=t("./DirectoryEntry"),r=new i(n.name,n.fullPath,o,n.nativeURL);e(r)},l=n&&function(t){n(new a(t))};r(s,l,"File","getParent",[this.toInternalURL()])},n.exports=o});