/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/

cordova.define("org.apache.cordova.file.FileWriter",function(t,e,i){var n=t("cordova/exec"),r=t("./FileError"),o=t("./ProgressEvent"),a=function(t){if(this.fileName="",this.length=0,t)this.localURL=t.localURL||t,this.length=t.size||0;this.position=0,this.readyState=0,this.result=null,this.error=null,this.onwritestart=null,this.onprogress=null,this.onwrite=null,this.onwriteend=null,this.onabort=null,this.onerror=null};a.INIT=0,a.WRITING=1,a.DONE=2,a.prototype.abort=function(){if(this.readyState===a.DONE||this.readyState===a.INIT)throw new r(r.INVALID_STATE_ERR);if(this.error=new r(r.ABORT_ERR),this.readyState=a.DONE,"function"==typeof this.onabort)this.onabort(new o("abort",{target:this}));if("function"==typeof this.onwriteend)this.onwriteend(new o("writeend",{target:this}))},a.prototype.write=function(t){var e,i=this,f="undefined"!=typeof window.Blob&&"undefined"!=typeof window.ArrayBuffer,s="windows8"===cordova.platformId||"windows"===cordova.platformId;if(!(t instanceof File||!s&&f&&t instanceof Blob)){if(e=f&&t instanceof ArrayBuffer,e&&"windowsphone"===cordova.platformId)t=Array.apply(null,new Uint8Array(t));if(this.readyState===a.WRITING)throw new r(r.INVALID_STATE_ERR);this.readyState=a.WRITING;var w=this;if("function"==typeof w.onwritestart)w.onwritestart(new o("writestart",{target:w}));n(function(t){if(w.readyState!==a.DONE){if(w.position+=t,w.length=w.position,w.readyState=a.DONE,"function"==typeof w.onwrite)w.onwrite(new o("write",{target:w}));if("function"==typeof w.onwriteend)w.onwriteend(new o("writeend",{target:w}))}},function(t){if(w.readyState!==a.DONE){if(w.readyState=a.DONE,w.error=new r(t),"function"==typeof w.onerror)w.onerror(new o("error",{target:w}));if("function"==typeof w.onwriteend)w.onwriteend(new o("writeend",{target:w}))}},"File","write",[this.localURL,t,this.position,e])}else{var h=new FileReader;if(h.onload=function(){a.prototype.write.call(i,this.result)},f)h.readAsArrayBuffer(t);else h.readAsText(t)}},a.prototype.seek=function(t){if(this.readyState===a.WRITING)throw new r(r.INVALID_STATE_ERR);if(t||0===t)if(0>t)this.position=Math.max(t+this.length,0);else if(t>this.length)this.position=this.length;else this.position=t},a.prototype.truncate=function(t){if(this.readyState===a.WRITING)throw new r(r.INVALID_STATE_ERR);this.readyState=a.WRITING;var e=this;if("function"==typeof e.onwritestart)e.onwritestart(new o("writestart",{target:this}));n(function(t){if(e.readyState!==a.DONE){if(e.readyState=a.DONE,e.length=t,e.position=Math.min(e.position,t),"function"==typeof e.onwrite)e.onwrite(new o("write",{target:e}));if("function"==typeof e.onwriteend)e.onwriteend(new o("writeend",{target:e}))}},function(t){if(e.readyState!==a.DONE){if(e.readyState=a.DONE,e.error=new r(t),"function"==typeof e.onerror)e.onerror(new o("error",{target:e}));if("function"==typeof e.onwriteend)e.onwriteend(new o("writeend",{target:e}))}},"File","truncate",[this.localURL,t])},i.exports=a});